/*
 * TestIO.java
 *
 * Created on 8 mars 2006, 13:37
 *
 */

package jus.apcoo.td.io;

import javax.swing.*;

import java.beans.PropertyVetoException;
import java.io.*;
import java.util.*;

import jus.util.Counter;

/**
 * Ce que vous devez complter dans ce TP
 * @author Sebastien Laborie
 */
public class TestIO extends GUI {
  // La liste de points
	private Collection<PointCartesien> listeDePoints;
	// la taille du Buffer
	protected static int TAILLEBUFFER = 256 * 1024;
	// le boolen pour inhiber l'affichage
	protected boolean affiche = true;
	// une mthode d'affichage pouvant tre inhibe
	protected void warning(String s){if(affiche) JOptionPane.showMessageDialog(this, s);}
	// un compteur pour quantifier le temps pris par une opration. l'unit est la
	// miliseconde.
	protected Counter counter;
	/**
	* Renvoie le texte contenu dans la zone de texte
	* @return String le contenu de la zone de texte
	*/
	protected String getZoneDeTexte() {return zoneDeTexte.getText();} 
	/**
	* Met  jour la zone de texte
	* @param String le nouveau contenu  afficher dans la zone de texte
	*/
	protected void setZoneDeTexte(String s) {zoneDeTexte.setText(s);}
	/**
	* Renvoie vrai si il faut bufferiser au chargement
	* @return boolean vrai si l'option bufferiser est selectionner
	*/
	protected boolean bufferiser(){return item_Bufferiser.isSelected();}
	/**
	* Renvoie vrai si il faut bufferiser au chargement
	* @return boolean vrai si l'option bufferiser est selectionner
	*/
  	protected void setBufferiser(boolean v){item_Bufferiser.setSelected(v);}
	/** 
	 * Creates a new instance of TestIO
	 */
	public TestIO() {
		super();
		// A COMPLETER
	}
	/**
	 * affiche la liste des points cartesiens
	 */
	protected void afficherLesPointsCartesiens() {
		StringBuffer str = new StringBuffer(listeDePoints.size() * 60);
		int i = 0;
		for(PointCartesien p : listeDePoints){str.append("Numero " + (++i) + " : " + p + "\n");}
		setZoneDeTexte(str.toString());
	}
	/**
	 * affiche la liste des coordonnes des points
	 */
	protected void afficherLesCoordonnees() {
		StringBuffer str = new StringBuffer(listeDePoints.size() * 30);
		for(PointCartesien p : listeDePoints){str.append(p.abscisse() + " " +  p.ordonnee() + "\n");}
		setZoneDeTexte(str.toString());
	}
	/**
	 * gnre une liste de points cartesiens
	 * @param int lengthnombre de points cartesiens a gnrer
	 */
	protected void genererListeDePoints(int n) {
		listeDePoints.clear();
		// A COMPLETER
		warning(listeDePoints.size() + " Points Crees.");
	}
	/**
	 * sauve la liste des points cartesiens en format texte
	 * @param File le fichier de sauvegarde
	 */
	protected void sauverFormatTexte(File f) {
		// A COMPLETER
	}
	/**
	 * sauve la liste des points cartesiens en format primitif
	 * @param File le fichier de sauvegarde
	 */
	protected void sauverFormatPrimitif(File f) {
		// A COMPLETER
	}
	/**
	 * sauve la liste des points cartesiens en format Objet
	 * @param File le fichier de sauvegarde
	 */
	protected void sauverFormatObjet(File f) {
		// A COMPLETER
	}
	/**
	 * charge une liste de points cartesiens en format texte
	 * @param File le fichier  charger
	 */
	protected void chargerFormatTexte(File f) {
		// A COMPLETER
	}
	/**
	 * charge une liste de points cartesiens en format primitif
	 * @param File le fichier  charger
	 */
	protected void chargerFormatPrimitif(File f) {
		// A COMPLETER
	}
	/**
	 * charge une liste de points cartesiens en format Objet
	 * @param File le fichier  charger
	 */
	protected void chargerFormatObjet(File f) {
		// A COMPLETER
	}
	/**
	 * Charge le contenu du fichier dans la zone de texte
	 * @param File le fichier a afficher
	 */
	protected void charger(File f) {
		// A COMPLETER
	}
	/**
	 * Sauve le contenu de la zone de texte dans le fichier
	 * @param File le fichier a sauvegarder
	 */
	protected void sauver(File f) {
		// A COMPLETER
	}
	/**
	 * Copie le contenu d'un fichier dans un autre fichier et affiche ce contenu
	 * dans la zone de texte
	 * @param File f1 - le fichier d'origine
	 * @param File f2 - le fichier destination
	 */
	protected void copier(File f1, File f2) {
		// A COMPLETER
	}
	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		try{
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			TestIO m = new TestIO();
			m.setVisible(true);
		}catch(Exception e){System.out.println(e);}
	}
}